/*$Id: FocusImpl.hh,v 1.18 2002/05/29 06:49:38 stefan Exp $
 *
 * This source file is a part of the Fresco Project.
 * Copyright (C) 1999 Stefan Seefeld <stefan@fresco.org> 
 * http://www.fresco.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 * MA 02139, USA.
 */
#ifndef _Berlin_FocusImpl_hh
#define _Berlin_FocusImpl_hh

#include <Fresco/config.hh>
#include <Fresco/Region.hh>
#include <Fresco/Focus.hh>
#include <Berlin/DefaultPOA.hh>
#include <vector>
#include <stack>

class FocusImpl : public virtual POA_Fresco::Focus,
                  public virtual PortableServer::RefCountServantBase,
                  private DefaultPOA
{
  friend class EventManager;
public:
  FocusImpl(Fresco::Input::Device device) : _device(device) {}
  virtual ~FocusImpl() {}
  virtual Fresco::Input::Device device() { return _device;}

  virtual bool request(Fresco::Controller_ptr) = 0;
  virtual void restore(Fresco::Region_ptr) = 0;
  virtual void damage(Fresco::Region_ptr) = 0;
  virtual void dispatch(Fresco::Input::Event &) = 0;
  PortableServer::POA_ptr _default_POA() { return DefaultPOA::_default_POA();}
protected:
  virtual void activate_composite() {}
private:
  const Fresco::Input::Device _device;
};

#endif
